using QwirkleClassLibrary;
namespace TestBase;

public class TestCell
{
    [Theory]
    [InlineData(true, 10, 20)]
    [InlineData(false, -10, -10)]
    [InlineData(false, 10, -10)]
    [InlineData(false, -10, 10)]

    public void Test_CellConstructor(bool isValid, int x, int y)
    {
        if (!isValid)
        {
            Assert.Throws<ArgumentException>(() => new Cell(x, y));
            return;
        }

        Cell c = new Cell(x, y);
        Assert.Equal(x, c.GetX);
        Assert.Equal(y, c.GetY);
    }
}